module Geocodable
  class Request
    class JSONParser < Faraday::Response::Middleware
      def on_complete(env)
        begin
          env.body = JSON.parse(env.body, symbolize_names: true) if is_json?(env)
        rescue JSON::ParserError
          raise APIError.new(
            "Invalid response object from API: #{env.body}", env.status, env.body)
        end
      end

      private

      def is_json?(env)
        env[:response_headers]['Content-Type'].match 'application/json'
      end
    end
  end
end
